package Fractal2D;

import java.awt.BorderLayout;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JSpinner.NumberEditor;

import Fractal2D.Data.ListMember;

public class FractalConfigJPanel extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JButton jButton1;
	private JLabel jLabel5;
	private JSpinner jSpinner4;
	private JLabel jLabel4;
	private JSpinner jSpinner3;
	private JSlider jSlider2;
	private JSpinner jSpinner2;
	private JPanel jPanel3;
	private JSlider jSlider1;
	private JLabel jLabel3;
	private JProgressBar jProgressBar1;
	private JPanel jPanel2;
	private JCheckBox jCheckBox1;
	private JSpinner jSpinner1;
	private JLabel jLabel1;
	private JPanel jPanel1;
	private FractalImplementor oFractalImplementor;
	public ArrayList<ListMember> oZoomMandelbrot = new ArrayList<ListMember>();
	public ArrayList<ListMember> oZoomJulia = new ArrayList<ListMember>();
	private boolean isMandelbrot = true;

	/**
	 * Auto-generated main method to display this JPanel inside a new JFrame.
	 */
	public FractalConfigJPanel() {
		super();
		initGUI();
		this.setMandelbrot(true);
	}

	public void setFractalImplmentor(FractalImplementor oFractalImplementor) {
		this.oFractalImplementor = oFractalImplementor;
	}

	private void initGUI() {
		try {
			// setPreferredSize(new Dimension(400, 300));
			BoxLayout thisLayout = new BoxLayout(this,
					javax.swing.BoxLayout.Y_AXIS);
			this.setLayout(thisLayout);
			{
				jPanel1 = new JPanel();
				FlowLayout jPanel1Layout = new FlowLayout();
				jPanel1.setLayout(jPanel1Layout);
				this.add(jPanel1);
				jPanel1.setBackground(new java.awt.Color(255, 255, 255));
				jPanel1.setEnabled(false);
				{
					jLabel4 = new JLabel();
					jPanel1.add(jLabel4);
					jLabel4.setText("Zoom: ");
				}
				{
					SpinnerNumberModel jSpinner4Model = new SpinnerNumberModel(
							10, 1.09, 20, 0.1);
					jSpinner4 = new JSpinner();
					jSpinner4.setModel(jSpinner4Model);
					NumberEditor oEditor = new NumberEditor(jSpinner4, "0.0");
					jSpinner4.setEditor(oEditor);
					jSpinner4.setBackground(new java.awt.Color(255, 255, 255));
					jPanel1.add(jSpinner4);
					jSpinner4.setFocusable(false);
				}
				{
					jLabel1 = new JLabel();
					jPanel1.add(jLabel1);
					jLabel1.setText("Iterations: ");
				}
				{
					SpinnerNumberModel oSpinnerNumberModel = new SpinnerNumberModel(
							63, 10, 100000, 1);
					jSpinner1 = new JSpinner(oSpinnerNumberModel);
					jPanel1.add(jSpinner1);
					jSpinner1.setFocusable(false);
					jSpinner1.setEnabled(false);
					jSpinner1.addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent evt) {
							jSpinner1StateChanged(evt);
						}
					});
				}
				{
					jCheckBox1 = new JCheckBox();
					jPanel1.add(jCheckBox1);
					jCheckBox1.setText("Adjust iterations");
					jCheckBox1.setSelected(true);
					jCheckBox1.setBackground(new java.awt.Color(255, 255, 255));
					jCheckBox1.setFocusable(false);
					jCheckBox1.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							jCheckBox1ActionPerformed(evt);
						}
					});

				}
				{
					jProgressBar1 = new JProgressBar();
					jPanel1.add(jProgressBar1);
					jProgressBar1.setValue(0);
					jProgressBar1.setBackground(new java.awt.Color(255, 255,
							255));
					jProgressBar1.setStringPainted(true);

					// jProgressBar1.setString("50% calculated");
					jProgressBar1.setFont(new java.awt.Font("Tahoma", 0, 10));
					jProgressBar1.addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent evt) {
							String newString = String.valueOf(jProgressBar1
									.getValue())
									+ "% calculated";
							jProgressBar1.setString(newString);
						}
					});

				}
				{
					jButton1 = new JButton();
					jPanel1.add(jButton1);
					jButton1.setText("Reset");
					jButton1.setMnemonic(java.awt.event.KeyEvent.VK_R);
					jButton1.setFocusable(false);
					jButton1.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							jButton1ActionPerformed(evt);
						}
					});
				}

			}
			{
				jPanel2 = new JPanel();
				BorderLayout jPanel2Layout = new BorderLayout();
				jPanel2.setLayout(jPanel2Layout);
				this.add(jPanel2);
				jPanel2.setBackground(new java.awt.Color(255, 255, 255));
				{
					jLabel3 = new JLabel();
					jPanel2.add(jLabel3, BorderLayout.WEST);
					BorderLayout jLabel3Layout = new BorderLayout();
					jLabel3.setLayout(jLabel3Layout);
					jLabel3.setText("<html>c<sub>r</sub>:</html>");
					// jLabel3.setMaximumSize(new java.awt.Dimension(40, 0));
				}

				{

					SpinnerNumberModel jSpinner2Model = new SpinnerNumberModel(
							-1.25, -5.0, 5.0, 0.0000111);
					jSpinner2 = new JSpinner();
					jSpinner2.setModel(jSpinner2Model);
					NumberEditor oEditor = new NumberEditor(jSpinner2,
							"0.0000000");
					jSpinner2.setEditor(oEditor);
					jPanel2.add(jSpinner2, BorderLayout.EAST);
					jSpinner2.setFocusable(false);
					jSpinner2.addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent evt) {
							jSlider1jSpinner2StateChanged(evt);
						}
					});

				}
				{
					jSlider1 = new JSlider();
					jPanel2.add(jSlider1, BorderLayout.CENTER);
					jSlider1.setBackground(new java.awt.Color(255, 255, 255));
					jSlider1.setMinorTickSpacing(1);
					jSlider1.setMajorTickSpacing(20);
					jSlider1.setMinimum(-50000000);
					jSlider1.setMaximum(50000000);
					jSlider1.setFocusable(false);
					// System.out.println(jSlider1.getSnapToTicks());
					jSlider1
							.setValue((int) (((Double) jSpinner2.getValue()) * 10000000));
					jSlider1.addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent evt) {
							jSlider1jSpinner2StateChanged(evt);
						}
					});

				}
			}
			{
				jPanel3 = new JPanel();
				BorderLayout jPanel3Layout = new BorderLayout();
				jPanel3.setLayout(jPanel3Layout);
				this.add(jPanel3);
				jPanel3.setBackground(new java.awt.Color(255, 255, 255));
				{
					SpinnerNumberModel jSpinner3Model = new SpinnerNumberModel(
							0.0, -5.0, 5.0, 0.0000111);
					jSpinner3 = new JSpinner();
					jSpinner3.setModel(jSpinner3Model);
					NumberEditor oEditor = new NumberEditor(jSpinner3,
							"0.0000000");
					jSpinner3.setEditor(oEditor);
					jPanel3.add(jSpinner3, BorderLayout.EAST);
					jSpinner3.setFocusable(false);
					jSpinner3.addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent evt) {
							jSlider2jSpinner3StateChanged(evt);
						}
					});
				}
				{
					jLabel5 = new JLabel();
					jPanel3.add(jLabel5, BorderLayout.WEST);
					jLabel5.setText("<html>c<sub>i</sub>:</html>");
					jLabel5.setLayout(null);
				}
				{
					jSlider2 = new JSlider();
					jPanel3.add(jSlider2, BorderLayout.CENTER);
					// System.out.println((int)(((Double)jSpinner3.getValue())*
					// 100000));
					//
					// jSlider2.setValue(400000);
					jSlider2.setMaximum(50000000);
					jSlider2.setMinimum(-50000000);
					jSlider2.setMajorTickSpacing(20);
					jSlider2.setMinorTickSpacing(1);
					jSlider2.setBackground(new java.awt.Color(255, 255, 255));
					jSlider2.setFocusable(false);
					jSlider2
							.setValue((int) (((Double) jSpinner3.getValue()) * 10000000));
					jSlider2.addChangeListener(new ChangeListener() {
						public void stateChanged(ChangeEvent evt) {
							jSlider2jSpinner3StateChanged(evt);
						}
					});

				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void jSlider1jSpinner2StateChanged(ChangeEvent evt) {

		if (evt.getSource().equals(jSlider1)) {
			double value = ((double) (jSlider1.getValue())) / 10000000;
			this.jSpinner2.setValue(new Double(value));
		} else {
			jSlider1
					.setValue((int) (((Double) jSpinner2.getValue()) * 10000000));
			if (this.oFractalImplementor != null)
				this.oFractalImplementor.setState(FractalImplementor.CHANGE);
		}

	}

	private void jSlider2jSpinner3StateChanged(ChangeEvent evt) {
		if (evt.getSource().equals(jSlider2)) {
			double value = ((double) (jSlider2.getValue())) / 10000000;
			this.jSpinner3.setValue(new Double(value));
		} else {
			jSlider2
					.setValue((int) (((Double) jSpinner3.getValue()) * 10000000));
			if (this.oFractalImplementor != null)
				this.oFractalImplementor.setState(FractalImplementor.CHANGE);
		}

	}

	private void jButton1ActionPerformed(ActionEvent evt) {
		// reset
		if (this.oFractalImplementor != null)
			this.oFractalImplementor.setState(FractalImplementor.RESET);
	}

	public void setMandelbrot(boolean isMandelbrot) {
		this.jLabel3.setEnabled(!isMandelbrot);
		this.jLabel5.setEnabled(!isMandelbrot);
		this.jSlider1.setEnabled(!isMandelbrot);
		this.jSlider2.setEnabled(!isMandelbrot);
		this.jSpinner2.setEnabled(!isMandelbrot);
		this.jSpinner3.setEnabled(!isMandelbrot);
		if (this.isMandelbrot != isMandelbrot
				&& this.oFractalImplementor != null)
			this.oFractalImplementor.setState(FractalImplementor.CHANGE);
		this.isMandelbrot = isMandelbrot;
	}

	public boolean isMandelbrot() {
		return this.isMandelbrot;
	}

	public void showProgress(boolean visible) {
		this.jProgressBar1.setVisible(visible);
		this.jProgressBar1.repaint();
	}

	public void setProgressValue(double value) {
		this.jProgressBar1.setString(String.valueOf(Math.round(value))
				+ "% calculated");
		this.jProgressBar1.setValue((int) Math.round(value));
	}

	private void jSpinner1StateChanged(ChangeEvent evt) {
		if (jSpinner1.isEnabled()) {
			if (this.oFractalImplementor != null)
				this.oFractalImplementor.setState(FractalImplementor.CHANGE);
		}
	}

	public double getZoom() {
		return (Double) this.jSpinner4.getValue();
	}

	public boolean adjustIterations() {
		return this.jCheckBox1.isSelected();
	}

	public int getIterations() {
		return (Integer) this.jSpinner1.getValue();
	}

	public void setIterations(int iterations) {
		this.jSpinner1.setValue(iterations);
	}

	public void setBack() {
		if (this.oFractalImplementor != null)
			this.oFractalImplementor.setState(FractalImplementor.BACK);
	}

	private void jCheckBox1ActionPerformed(ActionEvent evt) {
		// System.out.println("jCheckBox1.actionPerformed, event="+evt);
		if (this.jCheckBox1.isSelected()) {
			this.jSpinner1.setEnabled(false);
			if (this.oFractalImplementor != null)
				if (((int) this.oFractalImplementor.getAdjustedIterations()) != (Integer) jSpinner1
						.getValue()) {

					this.oFractalImplementor
							.setState(FractalImplementor.CHANGE);
					// jSpinner1.setValue((int)this.oFractalImplementor.
					// getCurrentIterations());
				}
		} else
			this.jSpinner1.setEnabled(true);
	}

	/**
	 * get c for z=z+c
	 * 
	 * @return
	 */
	public double[] getC() {
		double cr = (Double) jSpinner2.getValue();
		double ci = (Double) jSpinner3.getValue();
		return new double[] { cr, ci };
	}
}
