varying vec2 position;

uniform vec4 deltaVectorX1;
uniform vec4 deltaVectorX2;
uniform vec4 deltaVectorY1;
uniform vec4 deltaVectorY2;
uniform vec4 lowerLeftCornerX1;
uniform vec4 lowerLeftCornerX2;
uniform vec4 lowerLeftCornerY1;
uniform vec4 lowerLeftCornerY2;

//1/1024.0=0.0009765625
// the float mantissa has only 23 bits => number->number1 should be enough
void convertToBigSize(in float number,out vec4 number1, out vec4 number2){
	number1=vec4(0.0);
	number2=vec4(0.0);
	float signum=sign(number);
	number=abs(number);
	float temp=floor(number);
	number1.r=temp;
	number-=temp;
	number*=1024.0;
	temp=floor(number);
	number1.g=temp;
	number-=temp;
	number*=1024.0;
	temp=floor(number);
	number1.b=temp;
	number-=temp;
	number*=1024.0;
	temp=floor(number);
	number1.a=temp;
	number1*=signum;
}

//41 Ops
void add(inout vec4 a1, inout vec4 a2, in vec4 b1, in vec4 b2){
	a1+=b1;
	a2+=b2;
	//the values after the point have to be greater than 0.0
	a1.r-=2.0;//-2
	a2.a+=2048.0;
	a1.gba+=2046.0;
	a2.rgb+=2046.0;
		
	float temp=floor(a2.a*0.0009765625);
	a2.b+=temp;
	a2.a-=temp*1024.0;
		
	temp=floor(a2.b*0.0009765625);
	a2.g+=temp;
	a2.b-=temp*1024.0;
	
	temp=floor(a2.g*0.0009765625);
	a2.r+=temp;
	a2.g-=temp*1024.0;
	
	temp=floor(a2.r*0.0009765625);
	a1.a+=temp;
	a2.r-=temp*1024.0;
	
	temp=floor(a1.a*0.0009765625);
	a1.b+=temp;
	a1.a-=temp*1024.0;
	
	temp=floor(a1.b*0.0009765625);
	a1.g+=temp;
	a1.b-=temp*1024.0;
	
	temp=floor(a1.g*0.0009765625);
	a1.r+=temp;
	a1.g-=temp*1024.0;
	
}
//44+30+63=137ops
void mult(inout vec4 a1, inout vec4 a2, in vec4 b1, in vec4 b2){
	vec4 z11=a1*b1.r;
	vec4 z12=a2*b1.r;
	vec4 z21=a1*b1.g;
	vec4 z22=a2*b1.g;
	vec4 z31=a1*b1.b;
	vec4 z32=a2*b1.b;
	vec4 z41=a1*b1.a;
	vec4 z42=a2*b1.a;
	vec4 z51=a1*b2.r;
	vec4 z52=a2*b2.r;
	vec4 z61=a1*b2.g;
	vec4 z62=a2*b2.g;
	vec4 z71=a1*b2.b;
	vec4 z72=a2*b2.b;
	vec4 z81=a1*b2.a;
	vec4 z82=a2*b2.a;
	vec3 temp2=z82.gba;
	temp2.rg+=z72.ba;
	temp2.r+=z62.a;
	vec4 temp1=z52;
	temp1.a+=z82.r;
	temp1.rgb+=z81.gba;
	temp1.ba+=z72.rg;
	temp1.rg+=z71.ba;
	temp1.gba+=z62.rgb;
	temp1.r+=z61.a;
	temp1.rgb+=z42.gba;
	temp1.rg+=z32.ba;
	temp1.r+=z22.a;
	a2=z51;
	a2.a+=z81.r;
	a2.ba+=z71.rg;
	a2.gba+=z61.rgb;
	a2.a+=z42.r;
	a2.rgb+=z41.gba;
	a2.ba+=z32.rg;
	a2.rg+=z31.ba;
	a2.gba+=z22.rgb;
	a2.r+=z21.a;
	a2+=z12;
	a1=z11;
	a1.gba+=z21.rgb;
	a1.ba+=z31.rg;
	a1.a+=z41.r;
	
	float tempSign=sign(temp2.g);	
	float temp=floor(abs(temp2.g)*0.0009765625);
	temp2.r+=temp*tempSign;
	tempSign=sign(temp2.r);
	temp=floor(abs(temp2.r)*0.0009765625);
	temp1.a+=temp*tempSign;
	tempSign=sign(temp1.a);
	temp=floor(abs(temp1.a)*0.0009765625);
	temp1.b+=temp*tempSign;
	tempSign=sign(temp1.b);
	temp=floor(abs(temp1.b)*0.0009765625);
	temp1.g+=temp*tempSign;
	tempSign=sign(temp1.g);
	temp=floor(abs(temp1.g)*0.0009765625);
	temp1.r+=temp*tempSign;
	tempSign=sign(temp1.r);
	temp=floor(abs(temp1.r)*0.0009765625);
	a2.a+=temp*tempSign;
	
	tempSign=sign(a2.a);
	temp=floor(abs(a2.a)*0.0009765625);
	a2.b+=temp*tempSign;
	a2.a-=temp*1024.0*tempSign;
		
	tempSign=sign(a2.b);	
	temp=floor(abs(a2.b)*0.0009765625);
	a2.g+=temp*tempSign;
	a2.b-=temp*1024.0*tempSign;
	
	tempSign=sign(a2.g);	
	temp=floor(abs(a2.g)*0.0009765625);
	a2.r+=temp*tempSign;
	a2.g-=temp*1024.0*tempSign;
	
	tempSign=sign(a2.r);	
	temp=floor(abs(a2.r)*0.0009765625);
	a1.a+=temp*tempSign;
	a2.r-=temp*1024.0*tempSign;
	
	tempSign=sign(a1.a);	
	temp=floor(abs(a1.a)*0.0009765625);
	a1.b+=temp*tempSign;
	a1.a-=temp*1024.0*tempSign;
	
	tempSign=sign(a1.b);	
	temp=floor(abs(a1.b)*0.0009765625);
	a1.g+=temp*tempSign;
	a1.b-=temp*1024.0*tempSign;
	
	tempSign=sign(a1.g);	
	temp=floor(abs(a1.g)*0.0009765625);
	a1.r+=temp*tempSign;
	a1.g-=temp*1024.0*tempSign;
		
}

void main ()
{
	//position=lowerLeftCorner+(gl_Position.xy+vec2(1.0,1.0))*deltaVector;
	vec4 tempPositionX1=vec4(0.0);
	vec4 tempPositionX2=vec4(0.0);
	vec4 tempPositionY1=vec4(0.0);
	vec4 tempPositionY2=vec4(0.0);
	
	vec2 tmpPosition=position+1.0;
	convertToBigSize(tmpPosition.r,tempPositionX1, tempPositionX2);
	convertToBigSize(tmpPosition.g,tempPositionY1, tempPositionY2);
	
	mult(tempPositionX1,tempPositionX2, deltaVectorX1, deltaVectorX2);
	mult(tempPositionY1,tempPositionY2, deltaVectorY1, deltaVectorY2); 
	vec4 positionX1=lowerLeftCornerX1;
	vec4 positionX2=lowerLeftCornerX2;
	vec4 positionY1=lowerLeftCornerY1;
	vec4 positionY2=lowerLeftCornerY2;
	add(positionX1, positionX2, tempPositionX1, tempPositionX2);
	add(positionY1, positionY2, tempPositionY1, tempPositionY2);
	//first 10 bits of the mantissa are used for zX1, bit 11 for the sign of zX1
	//the next 10 bits are used for zX2, bit 22 for the sign of z
	vec4 signs=-ceil((sign(positionX1)-1.0)*0.5)*1024.0-ceil((sign(positionX2)-1.0)*0.5)*2097152.0;//1024*2048
	gl_FragData[0]=abs(positionX1)+abs(positionX2)*2048.0+signs;
	     signs=-ceil((sign(positionY1)-1.0)*0.5)*1024.0-ceil((sign(positionY2)-1.0)*0.5)*2097152.0;//1024*2048
	gl_FragData[1]=abs(positionY1)+abs(positionY2)*2048.0+signs;
}